/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : February, 1997                                                 */
/* File Name : JSSPMutationImpl.cc                                       */
/*************************************************************************/
/*************************************************************************/

#include "JSSPMutation.h"
#include "JSSPChromosomes.h"
#include "deffunc.h"
#include <MutationOperator.h>
#include <stdlib.h>
#include <stdio.h>

JSSPMutation::JSSPMutation()
{  debug = 0; 
}

JSSPMutation::~JSSPMutation()
{  cout << " de allocate JSSPMutation " << endl;
}

Chromosomes * JSSPMutation::apply(Chromosomes *_or)
{
   JSSPChromosomes *chro = (JSSPChromosomes *) _or;
   JSSPChromosomes *ret  = new JSSPChromosomes();
   int JobNum = (*chro).getNumOfJobs();
   int FacNum = (*chro).getNumOfFacs();
   int pick1 = (int) (rand() % JobNum);
   int pick2 = pick1;

   if(debug) cout << " in JSSPMutation::apply() " << endl;

   while(pick1==pick2) pick2 = (int) (rand() % JobNum);

   if(debug) cout << pick1 << " and " << pick2 << " should be swapped " << endl;
   cout << pick1 << " and " << pick2 << " should be swapped " << endl;

   int pickedMachine = (int) (rand() % FacNum);

   // construct the JSSPChromosomes

   (*ret).setOnlyMyProblem(*(*chro).getMyProblem());
   for(int i=0;i<FacNum;i++)
       (*ret).addFacilitySchedule(*(*chro).getFacilityScheduleIndex(i));

   cout << pick1 << " and " << pick2 << " should be swapped " ;
   cout << " on machine " << pickedMachine << endl;

   if(debug) 
   { cout << " the mutation object is " << endl ;
     (*ret).printOn(cout);
     cout << endl;
   }

   //(*ret).swapJobsOnMachine(pickedMachine,minimum(pick1,pick2),maximum(pick1,pick2));
   (*ret).swapJobsOrderOnMachine(pickedMachine,minimum(pick1,pick2),maximum(pick1,pick2));

   if(debug) cout << " let's see if it is feasible  pickedMachine  " << pickedMachine << endl;

   //(*ret).restore();

   if(!(*ret).isFeasible()) 
   //{ if(debug) cout << "It is not Feasible " << endl;
   {  cout << "It is not Feasible " << endl;
      (*ret).restore();
   } else cout << " It looks feasible " << endl ;

   if(debug) 
   { cout << " the mutation object is " << endl ;
     (*ret).printOn(cout);
     cout << endl;
   }

   return ret;

}// end of apply()

